/*
 * aprsgated.h - aprsgated public API
 * $Id: aprsgated.h,v 1.1.1.1 2003/03/25 07:14:40 augur Exp $
 *
 *   weather structures based on those in APRS World, copyright (c) James Jeffereson Jarvis
 * 
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *  
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
 * We want only raw sensor values.
	Wind Speed 
	Current Wind Direction 
	5 minute Wind Speed Peak 
	5 minute Wind Direction Peak 
	Wind Chill 
	Outdoor Temp 
	Rain Total for today 
	Barometer 
	Barometer Delta Value 
	Barometer Correction Factor
	Barometer Correction Factor
	Indoor Temp 
	Outdoor Humidity 
	Indoor Humidity 
	Dew Point 
	Date 
	Time 
*/
struct weather {
	int wind_direction;  /* 0-360 */
	int wind_speed;	/* kph */
	int temperature;	/* celcius */
	int in_temperature;	/* celcius */
	float rain_today;	/* centimeters */
	int humidity;  /* Percent RH */
	int in_humidity;  /* Percent RH */
	float barometer;	/* millibars */
	float baro_lsw; /* millibars? */
	float baro_msw;  /* millibars? */
} weather;


/* Weather data parsers must export this function */
int parse(struct weather *wx, char *record);

