/*
 * db.c - Ultimeter Logger database routines
 * $Id: db.c,v 1.1.1.1 2003/03/25 07:14:40 augur Exp $
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *  
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include <string.h>
#include <stdio.h>
#include <time.h>
#include <aprsgated/aprsgated.h>
#include <aprsgated/metric.h>
#include "db.h"


void weather_insert (struct weather *wx) {
	char s[4096];
    extern struct sql_insert sql_query;
    time_t rawtime;
    struct tm * timeinfo;
    
    /* Get the Current Time... */
    time ( &rawtime );
    timeinfo = localtime ( &rawtime );

	sql_insert_table(&sql_query,"DeviceValues");
	/*
		int wind_direction;  0-360
		int wind_speed;	 kph
		int temperature;	celcius
		int in_temperature; celcius
		float rain_today; centimeters
		int humidity;  Percent RH
		int in_humidity;  Percent RH
		float barometer; millibars
		float baro_lsw;  millibars?
		float baro_msw;  millibars?
	*/
	sql_insert_column(&sql_query,"device","0");
	sql_insert_column(&sql_query,"datetime","");
	sql_insert_column(&sql_query,"temperature","");
    sql_insert_column(&sql_query,"in_temperature","");
    sql_insert_column(&sql_query,"humidity","");
    sql_insert_column(&sql_query,"in_humidity","");
    sql_insert_column(&sql_query,"wind_direction","");
    sql_insert_column(&sql_query,"wind_speed","");
    sql_insert_column(&sql_query,"rain_today","");
    sql_insert_column(&sql_query,"barometer","");
	sql_insert_column(&sql_query,"baro_lsw","");
	sql_insert_column(&sql_query,"baro_msw","");

	snprintf(s,256,"1");
	sql_insert_value(&sql_query,s);
    /* DateTime must be in MySQL Format */
    strftime(s,256,"%Y-%m-%d %H:%M:%S", timeinfo);
	sql_insert_value(&sql_query,s);

	snprintf(s,256,"%d",wx->temperature);
	sql_insert_value(&sql_query,s);
	snprintf(s,256,"%d",wx->in_temperature);
	sql_insert_value(&sql_query,s);
	snprintf(s,256,"%d",wx->humidity);
	sql_insert_value(&sql_query,s);
	snprintf(s,256,"%d",wx->in_humidity);
	sql_insert_value(&sql_query,s);
	snprintf(s,256,"%d",wx->wind_direction);
	sql_insert_value(&sql_query,s);
	snprintf(s,256,"%d",wx->wind_speed);
	sql_insert_value(&sql_query,s);
	snprintf(s,256,"%f",wx->rain_today);
	sql_insert_value(&sql_query,s);
	snprintf(s,256,"%f",wx->barometer);
	sql_insert_value(&sql_query,s);
	snprintf(s,256,"%f",wx->baro_lsw);
	sql_insert_value(&sql_query,s);
	snprintf(s,256,"%f",wx->baro_msw);
	sql_insert_value(&sql_query,s);
	
	query(&sql_query,s,"INSERT");

	if (verbose & 4)
		printf ("%s;\n", s);

	if ( mysql_query (&mysql, s) )
		printf("Failed to INSERT \"%s\"\n",mysql_error (&mysql));
#if 0
	printf ("wind_direction: %d \n", wx->wind_direction);
	printf ("temperature: %d \n", wx->temperature);
	printf ("wind_speed: %d \n", wx->wind_speed);
	printf ("wind_gust: %d \n", wx->wind_gust);
	printf ("rain_calendar_day: %lf \n", wx->rain_calendar_day);
	printf ("rain_24hour_day: %lf \n", wx->rain_24hour_day);
	printf ("rain_hour: %lf \n", wx->rain_hour);
	printf ("humidity: %d \n", wx->humidity);
	printf ("barometer: %d \n", wx->barometer);
	printf ("wind_sustained: %d \n", wx->wind_sustained);
	printf ("luminosity: %d \n", wx->luminosity);
#endif
}

int log_mysql_error() {
	/* openlog("APRS Parser (MySQL)",LOG_PERROR,LOG_USER); */
	/* syslog(LOG_NOTICE,"MySQL error: %s\n",mysql_error(&mysql)); */
	/* closelog(); */
    return 0;
}


int make_sql_connection (char *host, char *username, char *password, char *database) {
	#ifndef LINUX
	mysql_init (&mysql);
	#endif

	if (!mysql_connect (&mysql, host, username, password)) {
		if (verbose & 1) {
			fprintf (stderr, "Failed to connect to database: Error: %s\n", mysql_error (&mysql));
		}
		return 1;
	}

	if (mysql_select_db (&mysql, database)) {
		if (verbose & 1) {
			fprintf (stderr, "Failed to select database: Error: %s\n", mysql_error (&mysql));
		}
		mysql_close (&mysql);
		return 2;
	}
}
