<?

function arcLength($x1, $y1, $x2, $y2) {
//printf("x1=%s y1=%s<BR>x2=%s y2=%s<BR>\n",$x1,$y1,$x2,$y2);
$pi = 3.1415926535;

$r = 3963.21; // Radius of earth in miles
//r = 20925748.8;      // Radius of earth in feet

$x1 *= ($pi/180.0);
$y1 *= ($pi/180.0);
$x2 *= ($pi/180.0);
$y2 *= ($pi/180.0);

$arcLength = cos($x1) * cos($y1) * cos($x2) * cos($y2) + cos($x1) * sin($y1) * cos($x2) * sin($y2) + sin($x1) * sin($x2);

$length = acos($arcLength) * $r;

return $length;
}

function mapblastPointUrl($lat, $lon, $name="", $width=600, $height=350) {
	return sprintf("http://www.mapblast.com/gif?&CT=%.5f:%.5f:8000:&IC=%.5f:%.5f:100:%s&FAM=myblast&W=%d&H=%d",$lat,$lon,$lat,$lon,urlencode($name),$width,$height);
}

function gazClosestPointUrl($lat, $lon, $name="", $limit=1, $feature_type="ppl" ) {
	return sprintf("gaz-near.php?lat=%.5f&lon=%.5f&name=%s&feature_type=%s&limit=%d",$lat,$lon,urlencode($name),$feature_type,$limit);
}

function datamartCloseStations($lat, $lon, $name="",$bbox_size=1 ) {
	return sprintf("stations-near.php?lat=%.5f&lon=%.5f&name=%s&bbox_size=%d",$lat,$lon,urlencode($name),$bbox_size);
}

function trackCall($source,$hours=72) {
	return sprintf("track-roads.php?call=%s&hours=%d",urlencode($source),$hours);
}

function mapserverPointUrl($lat, $lon, $name="", $scale="", $pad=0) {
	$x = $lon;
	$y = $lat;


	if ( $pad == 0 )
	switch ( $scale ) {
		case "country":
			$pad = 5;
			$break;
		case "regional":	
			$pad=1;
			break;
		case "city";
			$pad=0.1;
			break;
		case "street":
			$pad = 0.008;
			break;
	
		default:
			$pad=0.1;
	}


	$mapfile = "/var/www/html/mapserver/default.map";

	$url = "/cgi-bin/mapserv?mode=browse";
	$url .= sprintf("&map=%s",urlencode($mapfile));
	$url .= "&layers=streets+water+roads+lakes+countries+webuser+states+laspeed";
	$url .= sprintf("&map_webuser_feature=new&map_webuser_feature_points=%.4lf+%.4lf&map_webuser_feature_text=%s",$x,$y,urlencode($name));

	$url .= sprintf("&minx=%.4lf&miny=%.4lf&maxx=%.4lf&maxy=%.4lf",($x-$pad),($y-$pad),($x+$pad),($y+$pad));
	$url .= "&zoomsize=1";

	return $url;
}

?>
