<?
/** 
 * Generic functions for creating maps with Mapserver and PHP/MapScript
 *
 * @author James Jefferson Jarvis, KB0THN, kb0thn@aprsworld.net
 * 
 */

/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

define( "APP_PATH", "/var/www/html/map");
define( "APP_URL", "/map" );
define( "MS_MODULE", "php_mapscript.".PHP_SHLIB_SUFFIX );
define( "MS_BASE_URL", "/map/" );
define( "MS_TEMP_URL", "/tmp" );

function log_udp($text,$host="127.0.0.1",$port=3333) {
	$socket = socket_create(AF_INET, SOCK_DGRAM, SOL_UDP);
	$result = socket_connect($socket, $host, $port);
	socket_write($socket, $text, strlen($text));
	socket_close($socket);
}

function init($height,$width,$file="/var/www/html/map/maps/simple.map") {

	if (!extension_loaded( "mapscript" ))
   	 dl (MS_MODULE );
	
	/* create global map object */
	$GLOBALS["goMap"] = ms_newMapObj( $file );
 
 	/* return map in PNG format */
	$GLOBALS["goMap"]->selectOutputFormat("png");

	if ( 0 == $width || 0 == $height ) {
		$GLOBALS["goMap"]->set("width", 800);
		$GLOBALS["goMap"]->set("height", 550);
	} else {
		$GLOBALS["goMap"]->set("width", $width);
		$GLOBALS["goMap"]->set("height", $height);
	}

	ProcessURLArray( $aVars );
}

function setExtent($setextent) {
	/* NOTE: using $val = $oMap->extent->minx is a reference, not a value. */
	$GLOBALS["gfMinX"] = (float)$GLOBALS["goMap"]->extent->minx;
	$GLOBALS["gfMinY"] = (float)$GLOBALS["goMap"]->extent->miny;
	$GLOBALS["gfMaxX"] = (float)$GLOBALS["goMap"]->extent->maxx;
	$GLOBALS["gfMaxY"] = (float)$GLOBALS["goMap"]->extent->maxy;

	if ( "" != $setextent ) {
		$parts = explode("|",$setextent);
		/* Actually set the extent */
		$GLOBALS["goMap"]->setextent($parts[0], $parts[1], $parts[2], $parts[3]);
	}
}


function preRender($radar=0,$trackShapefilePath="",$areaShapefilePath="") {

	if ( $radar ) {
		for ( $i=0 ; $i<$GLOBALS["goMap"]->numlayers ; $i++ ) {
			$oLayer = $GLOBALS["goMap"]->getLayer($i);

			if ( "YES" != strtoupper($oLayer->getMetaData("WITHRADAR")) ) {
				/* leave status alone if withradar is set, otherwise turn off */
				$oLayer->set("status",MS_OFF);
			}
			if ( "YES" == strtoupper($oLayer->getMetaData("ISRADAR")) ) {
				/* turn on if this is a radar layer */
				$oLayer->set("status",MS_ON);
			}
		}
	}

	if ( "" != $trackShapefilePath ) {
		for ( $i=0 ; $i<$GLOBALS["goMap"]->numlayers ; $i++ ) {
			$oLayer = $GLOBALS["goMap"]->getLayer($i);

			if ( "YES" == strtoupper($oLayer->getMetaData("ISTRACK")) ) {
				/* turn on */
				$oLayer->set("status",MS_ON);
				$oLayer->set("data",$trackShapefilePath);
			}
		}
	}

	if ( "" != $areaShapefilePath ) {
		for ( $i=0 ; $i<$GLOBALS["goMap"]->numlayers ; $i++ ) {
			$oLayer = $GLOBALS["goMap"]->getLayer($i);

			if ( "YES" == strtoupper($oLayer->getMetaData("ISAREA")) ) {
				/* turn on */
				$oLayer->set("status",MS_ON);
				$oLayer->set("data",$areaShapefilePath);
			}
		}
	}

	/* do inital drawing, we can go back later and add our custom layer */
	/* returning an img */
	return $GLOBALS["goMap"]->draw();
}

//select from the available URL arrays
$aVars = (sizeof($_POST) > 0) ? $_POST : (sizeof($_GET) > 0) ? $_GET : array();
$GLOBALS["aVars"] = $aVars;

$GLOBALS["gszCurrentTool"] = "ZOOM_IN";

function GMapPix2Geo($nPixPos, $dfPixMin, $dfPixMax, $dfGeoMin, $dfGeoMax, $nInversePix) {
	$dfWidthGeo = $dfGeoMax - $dfGeoMin;
	$dfWidthPix = $dfPixMax - $dfPixMin;
	
	
	$dfPixToGeo = $dfWidthGeo / $dfWidthPix;
	
	if (!$nInversePix)
		$dfDeltaPix = $nPixPos - $dfPixMin;
	else
		$dfDeltaPix = $dfPixMax - $nPixPos;
		
	$dfDeltaGeo = $dfDeltaPix * $dfPixToGeo;
	
	$dfPosGeo = $dfGeoMin + $dfDeltaGeo;
	
	return ($dfPosGeo);
}


function getImageURL() {
	return $GLOBALS["image_url"];
}

function getImageFile() {
	return $GLOBALS["image_file"];
}

function getGeoURL() {
	return $GLOBALS["geo_url"];
}

function getGeo() {
	return $GLOBALS["geo"];
}

function renderMap($img,$filename,$db) {
	$image_file = "/var/www/html/tmp/" . $filename . ".png";
//	echo "image_file=" . $image_file;
	
	
//	if ( "track" == strtolower($_REQUEST["maptype"]) ) {
//		createAPRSTrackLayer($db, $img);
//	} else {
//		createAPRSAreaLayer( $db, $img );
//	}

	/* only draw lables if our scale in not too broad */
//	if ( $GLOBALS["goMap"]->scale <=	5905917 ) {
		$GLOBALS["goMap"]->drawLabelCache($img);
//	}
	
	$img->saveImage($image_file);
	$GLOBALS["url"] = "http://" . MAPSERVER_HOST . "/tmp/" . $filename . ".png";
	$GLOBALS["image_url"] = $GLOBALS["url"];
	$GLOBALS["image_file"] = $image_file;

	$nWidth = $GLOBALS["goMap"]->width;
	$nHeight = $GLOBALS["goMap"]->height;

	/* Create GEO file */
	$geo = sprintf("# map generated by geo.aprsworld.net and is Copyright %s, James Jefferson Jarvis KB0THN\n",date("Y"));
	$geo .= "# For information go visit http://geo.aprsworld.net/info/\n";
	$geo .= sprintf("URL %s\n",$GLOBALS["url"]);
	$geo .= "# Tiepoints in the corners\n";
	$geo .= sprintf("TIEPOINT %d %d %lf %lf\n",1,1, $GLOBALS["goMap"]->extent->minx,$GLOBALS["goMap"]->extent->maxy);
	$geo .= sprintf("TIEPOINT %d %d %lf %lf\n",$nWidth,$nHeight, $GLOBALS["goMap"]->extent->maxx,$GLOBALS["goMap"]->extent->miny);
	$geo .= sprintf("IMAGESIZE %d %d\n",$nWidth,$nHeight);

	$GLOBALS["geo"]=$geo;

	$hash_name = basename($GLOBALS["url"]);
	$hash_name = substr($hash_name,0,strpos($hash_name,"."));

	$geo_filename=sprintf("/var/www/html/tmp/%s.geo",$hash_name);
	$geo_fp = fopen($geo_filename,"w");
	fputs($geo_fp,$geo);
	fclose($geo_fp);
	
	$GLOBALS["geo_url"] = sprintf("/tmp/%s.geo",$hash_name);

	log_udp(sprintf("scale: %s geo url: %s\n",$GLOBALS["goMap"]->scale,$GLOBALS["geo_url"]));

	return;
	
}

/*
 * DrawScaleBar()
 */
function drawScaleBar() {
    $img = $GLOBALS["goMap"]->drawScaleBar();
    $url = $img->saveWebImage();
	 return $url;
}

/*
 * ProcessURLArray()
 * test an array of values and take action as necessary
 */
function ProcessURLArray( $aVars) {
	//record the current command
	$GLOBALS["gszCurrentTool"] = (isset($aVars["CMD"])) ? $aVars["CMD"] : "ZOOM_IN";
	
	//set up the previous extents
	if ( "" == $_REQUEST["sextent"] ) {
		$oExt = $GLOBALS["goMap"];
		$fMinX = isset($aVars["MINX"]) ? $aVars["MINX"] : $oExt->extent->minx;
		$fMinY = isset($aVars["MINY"]) ? $aVars["MINY"] : $oExt->extent->miny;;
		$fMaxX = isset($aVars["MAXX"]) ? $aVars["MAXX"] : $oExt->extent->maxx;;
		$fMaxY = isset($aVars["MAXY"]) ? $aVars["MAXY"] : $oExt->extent->maxy;;
	} else {
		$parts = explode("|",$_REQUEST["sextent"]);
		$fMinX = $parts[0];
		$fMinY = $parts[1];
		$fMaxX = $parts[2];
		$fMaxY = $parts[3];
	}
	
	$GLOBALS["goMap"]->setextent( $fMinX, $fMinY, $fMaxX, $fMaxY );
	
	//some short cuts
	$fWidthPix  = $GLOBALS["goMap"]->width;
	$fHeightPix = $GLOBALS["goMap"]->height;
	
	//process commands
	if (isset($aVars["CMD"])) {
		//determine where to navigate to.
		$nX = isset($aVars["MAINMAP_x"]) ? intval($aVars["MAINMAP_x"]) :
		$fWidthPix/2.0;
		$nY = isset($aVars["MAINMAP_y"]) ? intval($aVars["MAINMAP_y"]) :
		$fWidthPix/2.0;
	
		if (isset($aVars["MAINMAP_x"]) && isset($aVars["MAINMAP_y"])) {
			$oPixelPos = ms_newpointobj();
			$oPixelPos->setxy($nX, $nY);
			
			$oGeorefExt = ms_newrectobj();
			$oGeorefExt->setextent($fMinX, $fMinY, $fMaxX, $fMaxY);
			
			if ($aVars["CMD"] == "ZOOM_IN") {
				$GLOBALS["goMap"]->zoompoint(2, $oPixelPos, $fWidthPix,
				$fHeightPix, $oGeorefExt);
			} else if ($aVars["CMD"] == "ZOOM_OUT") {
				$GLOBALS["goMap"]->zoompoint(-2, $oPixelPos, $fWidthPix, $fHeightPix, $oGeorefExt);
			} else if ($aVars["CMD"] == "RECENTER") {
				$GLOBALS["goMap"]->zoompoint(1, $oPixelPos, $fWidthPix, $fHeightPix, $oGeorefExt);
			}  
		}

		if ($aVars["CMD"] == "ZOOM_FULL") {
			$GLOBALS["goMap"]->setextent($GLOBALS["gfMinX"],$GLOBALS["gfMinY"],$GLOBALS["gfMaxX"],$GLOBALS["gfMaxY"]);
		} 
	}
}

function IsCurrentTool( $szTool ) {
    return (strcasecmp($GLOBALS["gszCurrentTool"], $szTool) == 0);
}

function createAPRSTrackLayer( $db, $oImage ) {
	/* track on a station */
	if ( "" == $_REQUEST["call"] ) {
		$_REQUEST["call"] = "KB0THN-7";
	}
	
	/* only retrieve stations within our viewport */
	$sql = sprintF("SELECT * FROM position WHERE packet_date >= date_sub(now(),INTERVAL %lf MINUTE) AND source LIKE '%s' AND (latitude>=%lf AND latitude<=%lf) AND (longitude>=%lf AND longitude<=%lf)  ORDER BY packet_date DESC",$_REQUEST["minutes"],$_REQUEST["call"],$GLOBALS["goMap"]->extent->miny, $GLOBALS["goMap"]->extent->maxy, $GLOBALS["goMap"]->extent->minx,$GLOBALS["goMap"]->extent->maxx);

//	$GLOBALS["debug"][]=sprintf("SQL Query: %s<BR>\n",htmlspecialchars($sql));

	$query = mysql_query($sql,$db);

	$oLayer = $GLOBALS["goMap"]->getLayerByName("aprstrack");

	$stationCount=0;
	while ( $rec=mysql_fetch_array($query) ) {
		$stationCount++;

		/* Create the point shape */
		$oShape = ms_newShapeObj(MS_SHAPE_POINT);

		if ( 1 == $stationCount ) {
			/* add the label */
			$oShape->set("text", $rec["source"]);
		} else {
			$oShape->set("text","");
		}

		/* Which is defined as a line with a single point */
		$oLine = ms_newLineObj();

		/* We add a point to the line */
		$oLine->addXY((double) $rec["longitude"], (double) $rec["latitude"]);

		/* We add the line to the shape */
		$oShape->add($oLine);

		/* Add the feature to the layer */
		if ( -1 == $oLayer->addFeature($oShape) ) {
			printf("Error adding feature!<BR>\n");
			printf("lat: %lf lon: %lf source: %s ",$rec["latitude"],$rec["longitude"],$rec["source"]);
		}

		$oShape->free();
	}

	$GLOBALS["inViewCount"] = $stationCount;
	$oLayer->draw($oImage);
	
	return $stationCount;
}

function createAPRSAreaLayer( $db, $oImage ) {
	$sql = sprintf("SELECT * FROM lastposition WHERE packet_date >= date_sub(now(),INTERVAL %lf MINUTE) AND (latitude >= %lf && latitude <= %lf) AND (longitude >= %lf && longitude <= %lf)",$_REQUEST["minutes"],$GLOBALS["goMap"]->extent->miny, $GLOBALS["goMap"]->extent->maxy, $GLOBALS["goMap"]->extent->minx,$GLOBALS["goMap"]->extent->maxx);
//	$sql = sprintf("SELECT * FROM lastposition WHERE (latitude >= %lf && latitude <= %lf) AND (longitude >= %lf && longitude <= %lf)",$GLOBALS["goMap"]->extent->miny, $GLOBALS["goMap"]->extent->maxy, $GLOBALS["goMap"]->extent->minx,$GLOBALS["goMap"]->extent->maxx);

//	printf("DEBUG SQL Query createAPRSLayer(): %s<BR>\n",htmlspecialchars($sql));

	$query = mysql_query($sql,$db);

	$oLayer = $GLOBALS["goMap"]->getLayerByName("aprs");
	
	$stationCount=0;
	while ( $rec=mysql_fetch_array($query) ) {
		$stationCount++;

		/* Create the point shape */
		$oShape = ms_newShapeObj(MS_SHAPE_POINT);

		/* add the label */
		$label = $rec["source"];
//		if ( "" != $rec["status"] )
//			$label .= "\n" . $rec["status"];
		$oShape->set("text", $label);
		$oShape->set("classindex",0);

		/* Which is defined as a line with a single point */
		$oLine = ms_newLineObj();

		/* We add a point to the line */
		$oLine->addXY((double) $rec["longitude"], (double) $rec["latitude"]);

		/* We add the line to the shape */
		$oShape->add($oLine);

		/* Add the feature to the layer */
		if ( -1 == $oLayer->addFeature($oShape) ) {
			printf("Error adding feature!<BR>\n");
			printf("lat: %lf lon: %lf source: %s ",$rec["latitude"],$rec["longitude"],$rec["source"]);
		}

		$oShape->free();
	}

	$oLayer->draw($oImage);
	
	$GLOBALS["inViewCount"] = $stationCount;
	return $stationCount;
}

function createAPRSLastPosition( $db, $oImage, $call) {
	$sql = sprintf("SELECT * FROM lastposition WHERE source LIKE '%s' AND (latitude >= %lf && latitude <= %lf) AND (longitude >= %lf && longitude <= %lf)",$call,$GLOBALS["goMap"]->extent->miny, $GLOBALS["goMap"]->extent->maxy, $GLOBALS["goMap"]->extent->minx,$GLOBALS["goMap"]->extent->maxx);

//	printf("DEBUG SQL Query createAPRSLayer(): %s<BR>\n",htmlspecialchars($sql));

	$query = mysql_query($sql,$db);

	$oLayer = $GLOBALS["goMap"]->getLayerByName("aprs");
	
	$stationCount=0;
	while ( $rec=mysql_fetch_array($query) ) {
		$stationCount++;

		/* Create the point shape */
		$oShape = ms_newShapeObj(MS_SHAPE_POINT);

		/* add the label */
		$label = $rec["source"];
		if ( "" != $rec["status"] )
			$label .= "\n" . $rec["status"];
		$oShape->set("text", $label);
		$oShape->set("classindex",0);

		/* Which is defined as a line with a single point */
		$oLine = ms_newLineObj();

		/* We add a point to the line */
		$oLine->addXY((double) $rec["longitude"], (double) $rec["latitude"]);

		/* We add the line to the shape */
		$oShape->add($oLine);

		/* Add the feature to the layer */
		if ( -1 == $oLayer->addFeature($oShape) ) {
			printf("Error adding feature!<BR>\n");
			printf("lat: %lf lon: %lf source: %s ",$rec["latitude"],$rec["longitude"],$rec["source"]);
		}

		$oShape->free();
	}

	$oLayer->draw($oImage);
	
	$GLOBALS["inViewCount"] = $stationCount;
	return $stationCount;
}


function createPointLayer( $oImage, $latitude, $longitude, $label, $icon ) {

	$oLayer = $GLOBALS["goMap"]->getLayerByName("aprs");
	
	$stationCount=1;

	/* Create the point shape */
	$oShape = ms_newShapeObj(MS_SHAPE_POINT);

	/* add the label */
	$oShape->set("text", $label);
	$oShape->set("classindex",0);

	/* Which is defined as a line with a single point */
	$oLine = ms_newLineObj();

	/* We add a point to the line */
	$oLine->addXY((double) $longitude, (double) $latitude);

	/* We add the line to the shape */
	$oShape->add($oLine);

	/* Add the feature to the layer */
	if ( -1 == $oLayer->addFeature($oShape) ) {
		printf("Error adding feature!<BR>\n");
		printf("lat: %lf lon: %lf source: %s ",$latitude,$longitude,$source);
	}

	$oShape->free();

	$oLayer->draw($oImage);
	
	$GLOBALS["inViewCount"] = $stationCount;
	return $stationCount;
}




?>
