-- MySQL dump 10.10
--
-- Host: localhost    Database: aprs
-- ------------------------------------------------------
-- Server version	5.0.22-Debian_0ubuntu6.06.2-log

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `lastposition`
--

DROP TABLE IF EXISTS `lastposition`;
CREATE TABLE `lastposition` (
  `packet_id` int(11) unsigned NOT NULL default '0',
  `packet_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `source` varchar(9) NOT NULL default '',
  `latitude` double NOT NULL,
  `longitude` double NOT NULL,
  `course` smallint(5) unsigned default NULL,
  `speed` smallint(5) unsigned default NULL,
  `altitude` mediumint(9) default NULL,
  `status` tinytext,
  `symbol_table` char(1) default NULL,
  `symbol_code` char(1) default NULL,
  PRIMARY KEY  (`source`),
  KEY `source` (`source`),
  KEY `latitude` (`latitude`),
  KEY `longitude` (`longitude`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `laststatus`
--

DROP TABLE IF EXISTS `laststatus`;
CREATE TABLE `laststatus` (
  `packet_id` int(11) unsigned NOT NULL default '0',
  `packet_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `source` varchar(9) NOT NULL default '',
  `comment` tinytext,
  `power` tinyint(4) default NULL,
  `height` smallint(5) unsigned default NULL,
  `gain` tinyint(4) default NULL,
  `directivity` tinyint(4) default NULL,
  `rate` tinyint(4) default NULL,
  `symbol_table` char(1) default NULL,
  `symbol_code` char(1) default NULL,
  PRIMARY KEY  (`source`),
  KEY `source` (`source`),
  KEY `rate` (`rate`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `lastuserdefined`
--

DROP TABLE IF EXISTS `lastuserdefined`;
CREATE TABLE `lastuserdefined` (
  `packet_id` int(11) NOT NULL default '0',
  `source` varchar(10) NOT NULL default '',
  `packet_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `user_id` char(1) NOT NULL default '',
  `packet_type` char(1) NOT NULL default '',
  `information` tinytext NOT NULL,
  PRIMARY KEY  (`source`),
  KEY `source` (`source`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `lastweather`
--

DROP TABLE IF EXISTS `lastweather`;
CREATE TABLE `lastweather` (
  `packet_id` int(11) unsigned NOT NULL default '0',
  `source` char(9) NOT NULL default '',
  `packet_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `wind_direction` smallint(3) unsigned default NULL,
  `wind_speed` tinyint(4) unsigned default NULL,
  `wind_gust` tinyint(4) unsigned default NULL,
  `wind_sustained` tinyint(4) unsigned default NULL,
  `temperature` tinyint(4) default NULL,
  `rain_hour` float default NULL,
  `rain_calendar_day` float default NULL,
  `rain_24hour_day` float default NULL,
  `humidity` tinyint(4) unsigned default NULL,
  `barometer` double(4,2) unsigned default NULL,
  `luminosity` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`source`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `messages`
--

DROP TABLE IF EXISTS `messages`;
CREATE TABLE `messages` (
  `packet_id` int(10) unsigned NOT NULL default '0',
  `source` varchar(9) NOT NULL default '',
  `packet_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `addressee` varchar(10) default NULL,
  `text` varchar(73) default NULL,
  `id` varchar(10) default NULL,
  KEY `source` (`source`),
  KEY `addressee` (`addressee`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `msg2email_snoop_users`
--

DROP TABLE IF EXISTS `msg2email_snoop_users`;
CREATE TABLE `msg2email_snoop_users` (
  `source` varchar(10) NOT NULL default '',
  `recipient` text NOT NULL,
  `form` varchar(32) NOT NULL default 'simple.frm'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `msg2email_users`
--

DROP TABLE IF EXISTS `msg2email_users`;
CREATE TABLE `msg2email_users` (
  `source` varchar(9) NOT NULL default '',
  `email` text NOT NULL,
  `real_name` varchar(32) NOT NULL default '',
  `to_email` text NOT NULL,
  PRIMARY KEY  (`source`),
  UNIQUE KEY `source` (`source`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Callsign to e-mail address mapping';

--
-- Table structure for table `position`
--

DROP TABLE IF EXISTS `position`;
CREATE TABLE `position` (
  `packet_id` int(10) unsigned NOT NULL default '0',
  `source` char(9) NOT NULL default '',
  `packet_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `time_of_fix` int(10) unsigned default NULL,
  `latitude` double default NULL,
  `longitude` double default NULL,
  `course` smallint(5) unsigned default NULL,
  `speed` smallint(3) unsigned default NULL,
  `altitude` mediumint(5) default NULL,
  UNIQUE KEY `packet_id` (`packet_id`),
  KEY `source` (`source`),
  KEY `packet_date` (`packet_date`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `qa_hosts`
--

DROP TABLE IF EXISTS `qa_hosts`;
CREATE TABLE `qa_hosts` (
  `id` smallint(5) unsigned NOT NULL auto_increment,
  `host` varchar(255) NOT NULL default '',
  `active` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `id` (`id`),
  KEY `id_2` (`id`,`host`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Quality assurance hosts table';

--
-- Table structure for table `raw`
--

DROP TABLE IF EXISTS `raw`;
CREATE TABLE `raw` (
  `packet_id` int(10) unsigned NOT NULL auto_increment,
  `packet_time` int(10) unsigned NOT NULL default '0',
  `ip_source` varchar(255) default NULL,
  `source` varchar(9) NOT NULL default '',
  `destination` varchar(9) NOT NULL default '',
  `digipeater_0` varchar(9) default NULL,
  `digipeater_1` varchar(9) default NULL,
  `digipeater_2` varchar(9) default NULL,
  `digipeater_3` varchar(9) default NULL,
  `digipeater_4` varchar(9) default NULL,
  `digipeater_5` varchar(9) default NULL,
  `digipeater_6` varchar(9) default NULL,
  `digipeater_7` varchar(9) default NULL,
  `information` tinytext,
  `hostid` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`packet_id`),
  UNIQUE KEY `packet_id_2` (`packet_id`),
  KEY `packet_time` (`packet_time`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `status`
--

DROP TABLE IF EXISTS `status`;
CREATE TABLE `status` (
  `packet_id` int(10) unsigned NOT NULL default '0',
  `source` varchar(9) NOT NULL default '',
  `comment` tinytext,
  `power` tinyint(4) default NULL,
  `height` smallint(5) unsigned default NULL,
  `gain` tinyint(4) default NULL,
  `directivity` tinyint(4) default NULL,
  `rate` tinyint(4) default NULL,
  `symbol_table` char(1) default NULL,
  `symbol_code` char(1) default NULL,
  PRIMARY KEY  (`packet_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `telemetry`
--

DROP TABLE IF EXISTS `telemetry`;
CREATE TABLE `telemetry` (
  `packet_id` int(11) NOT NULL default '0',
  `source` char(10) NOT NULL default '',
  `packet_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `sequence` int(3) NOT NULL default '0',
  `analog_0` tinyint(3) unsigned NOT NULL default '0',
  `analog_1` tinyint(3) unsigned NOT NULL default '0',
  `analog_2` tinyint(3) unsigned NOT NULL default '0',
  `analog_3` tinyint(3) unsigned NOT NULL default '0',
  `analog_4` tinyint(3) unsigned NOT NULL default '0',
  `digital` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`packet_id`),
  KEY `source` (`source`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `telemetry_coefficients`
--

DROP TABLE IF EXISTS `telemetry_coefficients`;
CREATE TABLE `telemetry_coefficients` (
  `source` char(10) NOT NULL default '',
  `packet_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `a_0` double default NULL,
  `b_0` double default NULL,
  `c_0` double default NULL,
  `a_1` double default NULL,
  `b_1` double default NULL,
  `c_1` double default NULL,
  `a_2` double default NULL,
  `b_2` double default NULL,
  `c_2` double default NULL,
  `a_3` double default NULL,
  `b_3` double default NULL,
  `c_3` double default NULL,
  `a_4` double default NULL,
  `b_4` double default NULL,
  `c_4` double default NULL,
  KEY `source` (`source`,`packet_date`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `telemetry_labels`
--

DROP TABLE IF EXISTS `telemetry_labels`;
CREATE TABLE `telemetry_labels` (
  `packet_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `source` varchar(10) NOT NULL default '',
  `a_0` tinytext NOT NULL,
  `a_1` tinytext NOT NULL,
  `a_2` tinytext NOT NULL,
  `a_3` tinytext NOT NULL,
  `a_4` tinytext NOT NULL,
  `d_0` tinytext NOT NULL,
  `d_1` tinytext NOT NULL,
  `d_2` tinytext NOT NULL,
  `d_3` tinytext NOT NULL,
  `d_4` tinytext NOT NULL,
  `d_5` tinytext NOT NULL,
  `d_6` tinytext NOT NULL,
  `d_7` tinytext NOT NULL,
  KEY `source` (`source`),
  KEY `packet_date` (`packet_date`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `telemetry_units`
--

DROP TABLE IF EXISTS `telemetry_units`;
CREATE TABLE `telemetry_units` (
  `source` varchar(10) NOT NULL default '',
  `packet_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `a_0` tinytext NOT NULL,
  `a_1` tinytext NOT NULL,
  `a_2` tinytext NOT NULL,
  `a_3` tinytext NOT NULL,
  `a_4` tinytext NOT NULL,
  `d_0` tinytext NOT NULL,
  `d_1` tinytext NOT NULL,
  `d_2` tinytext NOT NULL,
  `d_3` tinytext NOT NULL,
  `d_4` tinytext NOT NULL,
  `d_5` tinytext NOT NULL,
  `d_6` tinytext NOT NULL,
  `d_7` tinytext NOT NULL,
  KEY `source` (`source`),
  KEY `packet_date` (`packet_date`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `userdefined`
--

DROP TABLE IF EXISTS `userdefined`;
CREATE TABLE `userdefined` (
  `packet_id` int(11) NOT NULL default '0',
  `source` varchar(10) NOT NULL default '',
  `packet_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `user_id` char(1) NOT NULL default '',
  `packet_type` char(1) NOT NULL default '',
  `information` tinytext NOT NULL,
  PRIMARY KEY  (`packet_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `watch_programs`
--

DROP TABLE IF EXISTS `watch_programs`;
CREATE TABLE `watch_programs` (
  `program` tinyint(4) unsigned NOT NULL default '0',
  `user` varchar(20) default NULL,
  `directory` text,
  `command` text NOT NULL,
  PRIMARY KEY  (`program`),
  UNIQUE KEY `program` (`program`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Listing of programs that can be triggered ';

--
-- Table structure for table `watch_users`
--

DROP TABLE IF EXISTS `watch_users`;
CREATE TABLE `watch_users` (
  `source` char(9) NOT NULL default '',
  `program` tinyint(4) unsigned NOT NULL default '0',
  KEY `source` (`source`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Callsigns that trigger external programs';

--
-- Table structure for table `weather`
--

DROP TABLE IF EXISTS `weather`;
CREATE TABLE `weather` (
  `packet_id` int(11) unsigned NOT NULL default '0',
  `source` char(9) NOT NULL default '',
  `packet_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `wind_direction` smallint(3) unsigned default NULL,
  `wind_speed` tinyint(4) unsigned default NULL,
  `wind_gust` tinyint(4) unsigned default NULL,
  `wind_sustained` tinyint(4) unsigned default NULL,
  `temperature` tinyint(4) default NULL,
  `rain_hour` float default NULL,
  `rain_calendar_day` float default NULL,
  `rain_24hour_day` float default NULL,
  `humidity` tinyint(4) unsigned default NULL,
  `barometer` double(4,2) unsigned default NULL,
  `luminosity` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`packet_id`),
  KEY `source` (`source`),
  KEY `packet_date` (`packet_date`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

