#include <stdio.h>
#include <string.h>

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

double atof();

#if 0
unsigned char
nmea_0183_checksum (char *p)
{
  int checksum, start, done;
  checksum = start = done = 0;

  for (; *p != '\0'; p++)
    {
    if (*p == '*')
		done = 1;
    if (start == 1 && done == 0)
		checksum = checksum ^ *p;	// XOR 
    if (*p == '$')
		start = 1;
    }
  return checksum;
}
#endif

int navitra_to_aprs(char *aprs, char *p)
{
int i,j,len;
char elements[20][20];    // Store each element until we can put in structure
int element, last, checksum;
unsigned char local_checksum; 
char buffer[256];

int hhmm;
double latitude;
double longitude;
int speed=0;
int direction=0;

char symbol_table[] = { '0', 'Y', 'B', 'G', 'R', '/', '/', '/', '\\', '/', '\\', '/', '/', '/', '\\' };
char symbol_code[] = { 'n', 'n', 'n', 'n', 'n', 'r', '-', 'V', ';', 'w', '<', '\'', 's', 'P', 'R' };

i=j=len=0;

local_checksum = nmea_0183_checksum (p);


if ( strstr(p,"$PNTS") )
	{
#if DEBUG
	printf("###################NAVI-TRA Packet##########################\n");
	printf("Information: %s\n",p);
#endif

	for (i = 0; i < 20; i++)
		strcpy (elements[i], "");

	i = 0;
	element = 0;
	len=strlen(p);

	for ( ; j < len && (element < 20) ; p++, i++, j++)
		{
		if ( last == ',' && *p == ',' )
			elements[element][0] = '\0';  // make it a string!

		if (last == ',')
			i=0;
		if (*p == ',')
			{
			elements[element][i] = '\0';  // make it a string!
			i = 0;
			element++;
			}
		elements[element][i] = last = *p;
		}
		elements[element][i] = '\0';  // make it a string!

#if 0
	for (i = 0; (i < 20); i++)
		if (strcmp (elements[i], ""))
			printf ("elements[%d]: %s\n", i, elements[i]);
#endif
	hhmm = atoi(elements[6]) / 100;
	latitude = atof(elements[7]);
	longitude = atof(elements[9]);
	speed = atoi(elements[12]);
	if ( atoi(elements[11]) )
		direction = 360 / atoi(elements[11]);
		else
		direction = 0;

	strtok(elements[16],"*");

	checksum=0;
	sscanf (strtok(NULL,"*"), "%2x", &checksum);
#if DEBUG
	printf ("Scanned checksum: %02x Calculated: %02x\n", checksum,local_checksum);
#endif

	if ( checksum == local_checksum )	// checksum is good
		{
		sprintf(aprs,"@%s%04dz",elements[3],hhmm);
		sprintf(buffer,"%04.2lf%s",latitude,elements[8]);
		strcat(aprs,buffer);
		sprintf(buffer,"%c",symbol_table[atoi(elements[13])]);
		strcat(aprs,buffer);
		sprintf(buffer,"%05.2lf%s",longitude,elements[10]);
		strcat(aprs,buffer);
		sprintf(buffer,"%c",symbol_code[atoi(elements[13])]);
		strcat(aprs,buffer);
		sprintf(buffer,"%03d/%03d/%s\n",direction,speed,elements[14]);
		strcat(aprs,buffer);
		} else {
		printf("Checksum failed!");
		return -1;
		}
	} 


return 0;
}

#if 0
int main(void)
{
char information[256];
char aprs[256];
//strcpy(information,"$PNTS,1,0,06,11,2001,002440,3531.676,N,13943.343,E,00,000,6,,000,1*28");
strcpy(information,"$PNTS,1,0,07,11,2001,214654,3546.793,N,13929.515,E,64,,5,TOKOROZAWA,000,1*16");

navitra_to_aprs(information,information);
printf("APRS PACKET:\n\t%s",information);
return 0;
}
#endif
