/*

APRS Parser with Database Support
Copyright (C) 2004 James Jefferson Jarvis	<kb0thn@aprsworld.net>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/* I think this motto was in mind when APRS was designed:
 * "Never make anything simple and efficient when a way can be found to make it
 * complex and wonderful" -- Found in the fortune
 */
 
#include <stdio.h>
#include <string.h>
#include <mysql.h>

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "sqlinsert.h"

void query(struct sql_insert *q, char *s, char *action)
{
char escaped[1024];
char buff[1024];

int i;
int j;

sprintf(buff,"%s INTO %s (",action,q->table_name);
strcpy(s,buff);


i=0;
j=0;
do	{
	if ( 0 != strcmp(q->column_value[i], q->column_null_value[i]) )
		{
		if ( 0 == i || 0 == j )
			{
			j=1;
			snprintf(buff,259,"%s",q->column_name[i]);
			}
			else
			snprintf(buff,259,",%s",q->column_name[i]);
		strcat(s,buff);
		}
	i++;
	} while ( 0 != strcmp(q->column_name[i],"") );
//sprintf(buff,") VALUES(");
strcat(s,") VALUES (");



// All values are enclosed in quotes and MySQL escaped
i=0;
j=0;
do	{
	if ( 0 != strcmp(q->column_value[i], q->column_null_value[i]) )
		{
		// BUG we should have a flag to indicate if we need to quote and escape
		if ( strcmp("unix_timestamp(now())",q->column_value[i]) && strcmp("now()",q->column_value[i]) ) {
		// Escape the string
			mysql_escape_string (escaped, q->column_value[i], strlen (q->column_value[i]));
			if ( 0 == i || 0 == j ) {
				j=1;
				sprintf(buff,"\"%s\"",escaped);
				} else {
				sprintf(buff,",\"%s\"",escaped);
				}
			} else {
			if ( 0 == i || 0 == j ) {
				j=1;
				sprintf(buff,"%s",q->column_value[i]);
				} else {
				sprintf(buff,",%s",q->column_value[i]);
				}
			}
			
		strcat(s,buff);
		}
		
	i++;
	} while ( 0 != strcmp(q->column_name[i],"") );
sprintf(buff,")");
strcat(s,buff);

}
void print_query(struct sql_insert *q)
{
char escaped[1024];

int i;
int j;
printf("INSERT INTO %s (",q->table_name);


i=0;
j=0;
do	{
	if ( 0 != strcmp(q->column_value[i], q->column_null_value[i]) ) {
		if ( 0 == i || 0 == j ) {
				j=1;
				printf("%s",q->column_name[i]);
			} else {
				printf(",%s",q->column_name[i]);
			}
	}
	i++;
	} while ( 0 != strcmp(q->column_name[i],"") );
printf(") VALUES(");



// All values are enclosed in quotes and MySQL escaped
i=0;
j=0;
do	{
	if ( 0 != strcmp(q->column_value[i], q->column_null_value[i]) )
		{
		// Escape the string
		mysql_escape_string (escaped, q->column_value[i], strlen (q->column_value[i]));
		if ( 0 == i || 0 == j ) {
				j=1;
				printf("\"%s\"",escaped);
			} else {
				printf(",\"%s\"",escaped);
			}
		}
		
	i++;
	} while ( 0 != strcmp(q->column_name[i],"") );
printf(")\n\n");

#if 0
i=0;
do {
	printf("\t(value)%s == %s(null value) (i=%d)\n",q->column_value[i],q->column_null_value[i],i);
	i++;
	} while ( 0 != strcmp(q->column_name[i],"") );
#endif

}

void sql_insert_column(struct sql_insert *q, char *name, char *null_value) {
	strcpy(q->column_name[q->index],name);
	strcpy(q->column_null_value[q->index++],null_value);
	
	//printf("[%d] %s\n",q->index,q->column_name[q->index-1]);
}

void sql_insert_value(struct sql_insert *q, char *value) {
	strcpy(q->column_value[q->val_index++],value);
	//printf("[%d] %s\n",q->val_index,q->column_value[q->val_index-1]);
}

void sql_insert_table(struct sql_insert *q, char *table_name) {
	q->index=0;
	q->val_index=0;
	strcpy(q->table_name,table_name);
}
		
#ifdef _SQLINSERT
int main(void) {
	int i;
	char s[4096];
	
	struct sql_insert sql_query;

	sql_insert_table(&sql_query,"messages");

	sql_insert_column(&sql_query,"packet_id","-1");
	sql_insert_column(&sql_query,"addressee","");
	sql_insert_column(&sql_query,"text","");
	sql_insert_column(&sql_query,"id","");
	sql_insert_column(&sql_query,"","");


	sql_insert_value(&sql_query,"1234");
	sql_insert_value(&sql_query,"KB0THN-7");
	sql_insert_value(&sql_query,"This message\'s has \\lots\\ to \"escape\"");
	sql_insert_value(&sql_query,"100");
	sql_insert_value(&sql_query,"");

	query(&sql_query,s);
	printf(s);
	//print_query(&sql_query);
}
#endif
