<?

function mysqltime2unixtime( $time ) {
	$timestamp=$time;
	$timestring = substr($timestamp, 0, 4) . '-' .
	substr($timestamp, 4, 2) . '-' .
	substr($timestamp, 6, 2) . ' ' .
	substr($timestamp, 8, 2) . ':' .
	substr($timestamp, 10, 2) . ':' .
	substr($timestamp, 12, 2);
	
	return strtotime($timestring);
	//return strtotime($time);	
}

function unixtime2plaintime( $time ) {
	return date("d-M-Y H:i:s",$time);
}

function gmdate2mysqltime( ) {
	return gmdate("Y-m-d H:i:s");
}

function unixtime2mysqltime( $time ) {
	return date("Y-m-d H:i:s",$time);
}

function arcLength($x1, $y1, $x2, $y2) {
	if ( $x1 == $x2 && $y1 == $y2 ) 
		return 0;

	$pi = 3.1415926535;

	$r = 3963.21; // Radius of earth in miles
	//r = 20925748.8;      // Radius of earth in feet

	$x1 *= ($pi/180.0);
	$y1 *= ($pi/180.0);
	$x2 *= ($pi/180.0);
	$y2 *= ($pi/180.0);

	$arcLength = cos($x1) * cos($y1) * cos($x2) * cos($y2) + cos($x1) * sin($y1) * cos($x2) * sin($y2) + sin($x1) * sin($x2);

	$length = acos($arcLength) * $r;

	return $length;
}

function rawTncUrl($packet_id) {
	return sprintf("http://%s/datamart/raw-tnc.php?packet_id=%d",DATAMART_HOST,$packet_id);
}

function mapblastPointUrl($lat, $lon, $name="", $width=600, $height=350) {
	return sprintf("http://www.vicinity.com/gif?&amp;CT=%.5f:%.5f:8000:&amp;IC=%.5f:%.5f:100:%s&amp;FAM=myblast&amp;W=%d&amp;H=%d",$lat,$lon,$lat,$lon,urlencode($name),$width,$height);
}

function gazClosestPointUrl($lat, $lon, $name="", $limit=1, $feature_type="ppl" ) {
	return sprintf("http://%s/datamart/gaz-near.php?lat=%.5f&amp;lon=%.5f&amp;name=%s&amp;limit=%d",DATAMART_HOST,$lat,$lon,urlencode($name),$limit);
}

function datamartCloseStations($lat, $lon, $name="",$bbox_size=1 ) {
	return sprintf("http://%s/map/near.phtml?lat=%.5f&amp;lon=%.5f&amp;name=%s&amp;bbox_size=%d&amp;maps=yes",MAPSERVER_HOST,$lat,$lon,urlencode($name),$bbox_size);
//	return sprintf("http://%s/datamart/stations-near.php?lat=%.5f&amp;lon=%.5f&amp;name=%s&amp;bbox_size=%d",DATAMART_HOST,$lat,$lon,urlencode($name),$bbox_size);
}

function trackCall($source,$hours=72) {
	return sprintf("http://%s/datamart/track-search.php?call=%s&amp;start_hours=%d",DATAMART_HOST,urlencode($source),$hours);
}

function mapserverImgUrl($lat, $lon, $name, $icon="", $scale="") {
	 return sprintf("http://%s/map/map.phtml?lat=%f&amp;lon=%f&amp;label=%s&amp;icon=%s&amp;scale=%s&amp;width=600&amp;height=350",MAPSERVER_HOST,$lat,$lon,urlencode($name),urlencode($icon),$scale);
	 //return sprintf("http://%s/mapserver/map.php?lat=%f&amp;lon=%f&amp;label=%s&amp;icon=%s&amp;scale=%s",MAPSERVER_HOST,$lat,$lon,urlencode($name),urlencode($icon),$scale);
}

function mapserverRadarImgUrl($lat, $lon, $name, $icon="", $scale="") {
	 return sprintf("http://maps.aprsworld.net/map/map.phtml?lat=%f&amp;lon=%f&amp;label=%s&amp;icon=%s&amp;scale=%s&radar=1&width=600&height=350",$lat,$lon,urlencode($name),urlencode($icon),$scale);
}


function mapserverLastposition($source,$scale="regional") {

	return sprintf("http://%s/map/lastposition.phtml?call=%s&amp;scale=%s&amp;width=600&amp;height=350",MAPSERVER_HOST,$source,$scale);
	//return sprintf("http://%s/mapserver/lastposition.php?call=%s&amp;scale=%s",MAPSERVER_HOST,$source,$scale);
}

function infoImageImgUrl($source) {
	return sprintf("http://%s/datamart/info-image.php?call=%s",DATAMART_HOST,$source);
}

function wxImageImgUrl($source) {
	return sprintf("http://%s/datamart/wx-image.php?call=%s",DATAMART_HOST,$source);
}

function mapserverPointUrl($lat, $lon, $name="", $scale="", $pad=0) {
	mapserverImgUrl($lat,$lon,$name,"",$scale);
}

function sortByDistance($a, $b ) {
	if ( $a["arcLength"] == $b["arcLength"] )
		return 0;
	if ( $a["arcLength"] > $b["arcLength"] )
		return 1;
	if ( $a["arcLength"] < $b["arcLength"] )
		return -1;
}

function closestCity($lat,$lon,$bbox_size=0.5) {
	$db = _open_mysql("gaz");

$queries=0;
$max_size = $bbox_size;
$bbox_size = 0.1;

do {
	/* Put us in the right hemisphere */
	if ( $lat < 0 ) {
		$lat1 = $lat - $bbox_size;
		$lat2 = $lat + $bbox_size;
		$lat1_sign = ">=";
		$lat2_sign = "<=";
	} else {
		$lat1 = $lat + $bbox_size;
		$lat2 = $lat - $bbox_size;
		$lat1_sign = "<=";
		$lat2_sign = ">=";
	}
	if ( $lon < 0 ) {
		$lon1 = $lon - $bbox_size;
		$lon2 = $lon + $bbox_size;
		$lon1_sign = ">=";
		$lon2_sign = "<=";
	} else {
		$lon1 = $lon + $bbox_size;
		$lon2 = $lon - $bbox_size;
		$lon1_sign = "<=";
		$lon2_sign = ">=";
	}


	$query = sprintf("SELECT * FROM usppl WHERE (latitude %s %s AND latitude %s %s) AND (longitude %s %s AND longitude %s %s)\n",$lat1_sign,$lat1,$lat2_sign,$lat2,$lon1_sign,$lon1,$lon2_sign,$lon2);

	if ( TRUE == $show_query ) {
		printf("MySQL = %s<BR>\n",$query);
		printf("bbox_size = %s<BR>\n",$bbox_size);
	}

	$q1 = mysql_query($query,$db);
	$queries++;

	$bbox_size += 0.1;
} while ( (0 == mysql_num_rows($q1)) && ($bbox_size <= $max_size) );

$i=0;
while ( $record = mysql_fetch_array($q1) ) {
	$data[$i]["country"] = $record["country"];
	$data[$i]["state"] = $record["state"];
	$data[$i]["county"] = $record["county"];
	$data[$i]["name"] = $record["name"];
	$data[$i]["latitude"] = $record["latitude"];
	$data[$i]["longitude"] = $record["longitude"];
	$data[$i]["arcLength"] = arcLength($lat,$lon,$data[$i]["latitude"],$data[$i]["longitude"]);
	$i++;
}

	if ( $i > 0 ) {
		usort($data, sortByDistance);

		return sprintf("%s, %s %s (%s)",$data[0]["name"],$data[0]["state"],$data[0]["country"],$data[0]["county"]);
	}

	return "";
}

function imageReplaceJavascript( ) {
?>
<SCRIPT TYPE="text/javascript"><!--
function show(imageName,imageSrc) {
    if (document.images) document.images[imageName].src = imageSrc;
	 }
//--></SCRIPT>
<?
}

function lastpositionScaleableMap( $source ) {
?>
<TABLE BORDER=1>
	<TR>
		<TD>
			<IMG NAME="<? echo $source; ?>" SRC="<? echo mapserverLastposition($source,"regional"); ?>" ALT="<? printf("%s's last location map",$source); ?>">
		</TD>
		<TD>
			<B>Select zoom scale:</B>
			<HR />
			<INPUT TYPE=RADIO NAME="scale" VALUE="street" onfocus="show('<? echo $source; ?>','<? echo mapserverLastposition($source,"street"); ?>')">Street
			<HR />
			<INPUT TYPE=RADIO NAME="scale" VALUE="town" onfocus="show('<? echo $source; ?>','<? echo mapserverLastposition($source,"town"); ?>')">Town
			<HR />
			<INPUT TYPE=RADIO NAME="scale" VALUE="county" onfocus="show('<? echo $source; ?>','<? echo mapserverLastposition($source,"county"); ?>')">County
			<HR />
			<INPUT CHECKED TYPE=RADIO NAME="scale" VALUE="regional" onfocus="show('<? echo $source; ?>','<? echo mapserverLastposition($source,"regional"); ?>')">Regional
			<HR />
		</TD>
	</TR>
</TABLE>
</DIV>
<?
}

function mapserverScaleableRadarMap( $lat, $lon, $name, $icon="") {

//	$icon = ""; // Fixme: Map does not work if icon value is passed through.

	$hash = md5($name . $lat . $lon . $icon);
?>
<TABLE BORDER=1>
	<TR>
		<TD>
			<IMG NAME="<? echo $name; ?>" SRC="<? echo mapserverRadarImgUrl($lat,$lon,$name,$icon); ?>" ALT="<? printf("%s's map",$name); ?>">
		</TD>
		<TD>
			<B>Select zoom scale:</B>
			<HR />
			<FORM NAME="<? echo $hash; ?>" ACTION="">
			<INPUT TYPE=RADIO NAME="scale" VALUE="street" onfocus="show('<? echo $name; ?>','<? echo mapserverRadarImgUrl($lat,$lon,$name,$icon,"street"); ?>')">Street
			<HR />
			<INPUT TYPE=RADIO NAME="scale" VALUE="town" onfocus="show('<? echo $name; ?>','<? echo mapserverRadarImgUrl($lat,$lon,$name,$icon,"town"); ?>')">Town
			<HR />
			<INPUT TYPE=RADIO NAME="scale" VALUE="county" onfocus="show('<? echo $name; ?>','<? echo mapserverRadarImgUrl($lat,$lon,$name,$icon,"county"); ?>')">County
			<HR />
			<INPUT CHECKED TYPE=RADIO NAME="scale" VALUE="regional" onfocus="show('<? echo $name; ?>','<? echo mapserverRadarImgUrl($lat,$lon,$name,$icon,"regional"); ?>')">Regional
			<HR />
			</FORM>
		</TD>
	</TR>
</TABLE>
<?
}

function mapserverScaleableMap( $lat, $lon, $name, $icon="") {

//	$icon = ""; // Fixme: Map does not work if icon value is passed through.

	$hash = md5($name . $lat . $lon . $icon);
?>
<TABLE BORDER=1>
	<TR>
		<TD>
			<IMG NAME="<? echo $name; ?>" SRC="<? echo mapserverImgUrl($lat,$lon,$name,$icon); ?>" ALT="<? printf("%s's map",$name); ?>">
		</TD>
		<TD>
			<B>Select zoom scale:</B>
			<HR />
			<FORM NAME="<? echo $hash; ?>" ACTION="">
			<INPUT TYPE=RADIO NAME="scale" VALUE="street" onfocus="show('<? echo $name; ?>','<? echo mapserverImgUrl($lat,$lon,$name,$icon,"street"); ?>')">Street
			<HR />
			<INPUT TYPE=RADIO NAME="scale" VALUE="town" onfocus="show('<? echo $name; ?>','<? echo mapserverImgUrl($lat,$lon,$name,$icon,"town"); ?>')">Town
			<HR />
			<INPUT TYPE=RADIO NAME="scale" VALUE="county" onfocus="show('<? echo $name; ?>','<? echo mapserverImgUrl($lat,$lon,$name,$icon,"county"); ?>')">County
			<HR />
			<INPUT CHECKED TYPE=RADIO NAME="scale" VALUE="regional" onfocus="show('<? echo $name; ?>','<? echo mapserverImgUrl($lat,$lon,$name,$icon,"regional"); ?>')">Regional
			<HR />
			</FORM>
		</TD>
	</TR>
</TABLE>
<?
}



/** latitude / longitude to maidenhead grid square.
 *
 * @param $latitude signed latitude in decimal degrees 
 * @param $longitude signed longitude in decimal degrees
 *
 * @return 6 character grid square (example: "EN43EX")
 */
function maidenhead($latitude, $longitude) {
	if ( abs($latitude) > 90 || abs($longitude) > 180 ) {
		return "Invalid coordinates.";
	}

	$longitude += 180;
	$latitude += 90;
	$grid = chr( 65 + (int) ($longitude / 20));
	$grid .= chr( 65 + (int) ($latitude / 10));
	$grid .= chr( 48 + (int) (($longitude/2) % 10));
	$grid .= chr( 48 + (int) ($latitude % 10));

	$grid .= chr(65 + (int) (fmod( $longitude , 2.0 ) * 12.0 ));
	$grid .= chr(65 + (int) (fmod( $latitude , 1.0 ) * 24.0 ));

	return $grid;

}

function stationDetailLink($call,$maps=TRUE) {

	if ( $maps ) {
		return sprintf("<A HREF=\"http://%s/datamart/station-list.php?maps=yes&amp;call=%s\">%s</A>",DATAMART_HOST,$call,$call);
	} 

	return sprintf("<A HREF=\"http://%s/datamart/station-list.php?call=%s\">%s</A>",DATAMART_HOST,$call,$call);

}

function urlToClickable($status) {
	$status = eregi_replace("(http|https|ftp)://([[:alnum:]/\n+-=%&:_.~?]+[#[:alnum:]+]*)","<A HREF=\"\\1://\\2\">\\1://\\2</A>",$status); 
	$status = eregi_replace("([\._a-z0-9-]+)@([\._a-z0-9-]+)", "<A HREF=\"mailto:\\1@\\2\">\\1@\\2</A>", $status);
	
	return $status;
}

function getWeatherLink($call) {
	return sprintf("http://%s/datamart/weather-list.php?call=%s",DATAMART_HOST,urlencode($call));
}

function decodeDirectivity($d) {

	$d = (int) $d;

	$table = array("Omni","45&deg; NE","90&deg; E","135&deg; SE","180&deg; S","225&deg; SW","270&deg; W","315&deg; NW","360&deg; N");

	if ( $d < 0 || $d > 8 ) {
		return "Unknown&deg;";
	}

	return $table[$d];

}

function dateSelect($prefix,$useSelected=1,$timestamp=-1) {
	if ( -1 == $timestamp ) {
		$timestamp=time();
	}
	$months = array("January","February","March","April","May","June","July","August","September","October","November","December");

	printf("<SELECT NAME=\"%s_year\" SIZE=1>\n",$prefix);
	for ( $i=date("Y")+1 ; $i>=2002 ; $i-- ) {
		if ( $useSelected && $i == date("Y",$timestamp) ) 
			$selected=" SELECTED";
		else
			$selected="";

		printf("<OPTION VALUE=\"%d\"%s>%d</OPTION>\n",$i,$selected,$i);
	}
	printf("</SELECT>\n");

	printf("<SELECT NAME=\"%s_month\" SIZE=1>\n",$prefix);
	for ( $i=0 ; $i<12 ; $i++ ) {
		if ( $useSelected && $i == date("m",$timestamp)-1 ) 
			$selected=" SELECTED";
		else
			$selected="";

		printf("<OPTION VALUE=\"%d\"%s>%s</OPTION>\n",$i+1,$selected,$months[$i]);
	}
	printf("</SELECT>\n");

	printf("<SELECT NAME=\"%s_day\" SIZE=1>\n",$prefix);
	for ( $i=1 ; $i<=31 ; $i++ ) {
		if ( $useSelected && $i == date("d",$timestamp) ) 
			$selected=" SELECTED";
		else
			$selected="";

		printf("<OPTION VALUE=\"%d\"%s>%d</OPTION>\n",$i,$selected,$i);
	}
	printf("</SELECT>\n");

}

function timeSelect($prefix,$useSelected=1,$timestamp=-1) {
	if ( -1 == $timestamp ) {
		$timestamp=time();
	}

	printf("<SELECT NAME=\"%s_hour\" SIZE=1>\n",$prefix);
	for ( $i=0 ; $i<=23 ; $i++ ) {
		if ( $useSelected && $i == date("H",$timestamp) ) 
			$selected=" SELECTED";
		else
			$selected="";

		printf("<OPTION VALUE=\"%d\"%s>%d</OPTION>\n",$i,$selected,$i);
	}
	printf("</SELECT>\n");

	printf("<SELECT NAME=\"%s_minute\" SIZE=1>\n",$prefix);
	for ( $i=0 ; $i<=59 ; $i++ ) {
		if ( $useSelected && $i == date("i",$timestamp) ) 
			$selected=" SELECTED";
		else
			$selected="";

		printf("<OPTION VALUE=\"%d\"%s>%d</OPTION>\n",$i,$selected,$i);
	}
	printf("</SELECT>\n");

}

function getLastLatLon($db, $source) {
	$sql = sprintf("SELECT latitude, longitude FROM lastposition WHERE source='%s'",$source);
	$query = mysql_query($sql,$db);

	$record = mysql_fetch_array($query);

	return sprintf("%2.4lf %3.4lf",$record["latitude"],$record["longitude"]);

}

/* turn status information into human readable */
function humanStatus($row,$metric) {

	$status="";

	if ( $row["power"] > 0 ) {
		$status .= sprintf("Power: %d watts ",$row["power"]);
	}
	if ( $row["height"] != "" ) {
		$status .= sprintf("Height: %d %s ",$row["power"],getUnitByName("altitude",$metric));
	}
	if ( $row["gain"] != "" ) {
		$status .= sprintf("Gain: %d dB ",$row["gain"]);
	}
	if ( $row["rate"] != "" ) {
		$status .= sprintf("Rate: %d / hour ",$row["rate"]);
	}

	if ( strlen($status) > 0 ) {
		$status .= "<BR>\n";
	}

	return $status;

}

function getWeatherPlot($call) {
	return sprintf("http://%s/datamart/gnuplot/weather-plot.php?call=%s",DATAMART_HOST,urlencode($call));
}

function getQrzLink($call) {

	if ( strpos($call,"-") ) {
		$call=substr($call,0,strpos($call,"-"));
	}

	return sprintf("http://www.qrz.com/callsign/%s",strtoupper($call));
}

function windChill($t_in, $v_in) {
	/* formula from http://www.nws.noaa.gov/om/windchill/index.shtml 
	original implementation courtosey of Clare Jarvis, K0NY */
	/* needs $t to be temperature in celsisus and $v to wind speed in kph */
	$t = $t_in*1.8 + 32.0;
	$v = $v_in * 0.62137;

	/* if wind is less than 5 MPH then considered calm and return original temp */
	if ( $v < 5 || $t > 40 ) 
		return $t_in;
	

	$wc_english = (35.75 +0.6215*$t -35.75*pow($v,0.16)  + 0.4275*$t*pow($v,0.16));
	$wc_metric = ($wc_english-32.0)*0.5556;

	return $wc_metric;
}

function taggedUrlToClickable($status,$class="") {
	$status = eregi_replace("(LINK:http|LINK:https|LINK:ftp)://([[:alnum:]/\n+-=%&:_.~?]+[#[:alnum:]+]*)","<A HREF=\"\\1://\\2\" ##CLASS##>\\1://\\2</A>",$status);
	$status = eregi_replace("(IMG:http|IMG:https)://([[:alnum:]/\n+-=%&:_.~?]+[#[:alnum:]+]*)","<IMG SRC=\"\\1://\\2\" ALT=\"\">",$status);
	$status = eregi_replace("([\._a-z0-9-]+)@([\._a-z0-9-]+)", "<A HREF=\"mailto:\\1@\\2\" ##CLASS##>\\1@\\2</A>", $status);
	$ct = sprintf("CLASS=\"%s\"",$class);
	$status = str_replace("##CLASS##",$ct ,$status);
	$status = str_replace("LINK:","" ,$status);
	$status = str_replace("IMG:","" ,$status);
	
	return $status;
}

function getMapserverAreaCentered($lat,$lon,$minutes=15,$radar=0,$width=640,$height=480,$latpad=1,$lonpad=1) {
	$minx=$lon-$lonpad;
	$maxx=$lon+$lonpad;
	$miny=$lat-$latpad;
	$maxy=$lat+$latpad;

	return sprintf("http://maps.aprsworld.net/map/stations.phtml?minx=%lf&maxx=%lf&miny=%lf&maxy=%lf&minutes=%d&nocache=1&radar=%d&width=%d&height=%d",
		$minx,
		$maxx,
		$miny,
		$maxy,
		$minutes,
		$radar,
		$width,
		$height
	);
}

function mapserverScaleableAreaMapCenter($lat,$lon,$minutes=15,$radar=0,$width=640,$height=480,$latpad=1,$lonpad=1) {

	$hash = md5(uniqid("mapserverScaleableAreaMapCenter"));
?>
<TABLE BORDER=1>
	<TR>
		<TD>
			<IMG NAME="<? echo $name; ?>" SRC="<? echo getMapserverAreaCentered($lat,$lon,$minutes,$radar,$width,$height,$latpad,$lonpad); ?>" ALT="<? printf("%s's map",$name); ?>" WIDTH=<? echo $width; ?> HEIGHT=<? echo $height; ?>>
		</TD>
		<TD>
			<B>Select zoom scale:</B>
			<HR />
			<FORM NAME="<? echo $hash; ?>" ACTION="">
			<INPUT TYPE=RADIO NAME="scale" VALUE="street" onfocus="show('<? echo $name; ?>','<? echo mapserverImgUrl($lat,$lon,$name,$icon,"street"); ?>')">Street
			<HR />
			<INPUT TYPE=RADIO NAME="scale" VALUE="town" onfocus="show('<? echo $name; ?>','<? echo mapserverImgUrl($lat,$lon,$name,$icon,"town"); ?>')">Town
			<HR />
			<INPUT TYPE=RADIO NAME="scale" VALUE="county" onfocus="show('<? echo $name; ?>','<? echo mapserverImgUrl($lat,$lon,$name,$icon,"county"); ?>')">County
			<HR />
			<INPUT CHECKED TYPE=RADIO NAME="scale" VALUE="regional" onfocus="show('<? echo $name; ?>','<? echo mapserverImgUrl($lat,$lon,$name,$icon,"regional"); ?>')">Regional
			<HR />
			</FORM>
		</TD>
	</TR>
</TABLE>
<?
}

function getGeocodeLink($lat,$lon,$id) {

	return sprintf("http://geo.aprsworld.net/geocode/geocode.php?lat=%lf&amp;lon=%lf&amp;id=%s",$lat,$lon,$id);

}

function mapserverGeoImgUrl($lat, $lon, $name, $icon="", $scale="") {
	 return sprintf("http://maps.aprsworld.net/map/map.phtml?lat=%f&amp;lon=%f&amp;label=%s&amp;icon=%s&amp;scale=%s",$lat,$lon,urlencode($name),urlencode($icon),$scale);
}

/* contributed by Jon Freilich <jon@freilich.com> and modified by James Jarvis */
function courseToCardinal($course) { 
	if ( ($course >= 338) || ($course < 23) || ($course == 0)) 
		$cardinal = "N";
	if (($course >= 23) && ($course < 68)) 
		$cardinal = "NE"; 
	if (($course >= 68) && ($course < 113)) 
		$cardinal = "E"; 
	if (($course >= 113) && ($course < 158)) 
		$cardinal = "SE";
	if (($course >= 158) && ($course < 203))
		$cardinal = "S";
	if (($course >= 203) && ($course < 248))
		$cardinal = "SW";
	if (($course >= 248) && ($course < 293))
		$cardinal = "W";
	if (($course >= 293) && ($course < 338))
		$cardinal = "NW";
	
	return $cardinal;
}

function getOutsideMapList($lat,$lon,$label) {
	$s=array();
	$s[]="Google Maps|http://maps.google.com/maps?q=##LABEL##&ll=##LAT##%2C##LON##&spn=0.006714%2C0.014455";
	$s[]="ACME Mapper USA Satellite Image|http://www.acme.com/mapper/?lat=##LAT##&long=##LON##&theme=Image";
	$s[]="ACME Mapper USA Topo Map|http://www.acme.com/mapper/?lat=##LAT##&long=##LON##&theme=Topo";
	$s[]="MSN Europe|http://www.mapblast.com/map.aspx?L=EUR&C=##LAT##%2c##LON##&A=7.16667&P=|##LAT##%2c##LON##|1|##LABEL##|L1|";
	$s[]="MSN USA|http://www.mapblast.com/map.aspx?L=USA0409&C=##LAT##%2c##LON##&A=7.16667&P=|##LAT##%2c##LON##|1|##LABEL##|L1|";
	$s[]="MSN World Wide|http://www.mapblast.com/map.aspx?L=WLD0409&C=##LAT##%2c##LON##&A=7.16667&P=|##LAT##%2c##LON##|1|##LABEL##|L1|";
?>
<FORM METHOD=POST ACTION="http://aprsworld.net/jump.php">
	<SELECT NAME="location" SIZE=1>
<?
	for ( $i=0 ; $i<count($s) ; $i++ ) {
		$parts=explode("|",$s[$i]);
		$l=substr($s[$i],strlen($parts[0])+1);
		$l = str_replace("##LAT##",$lat,$l);
		$l = str_replace("##LON##",$lon,$l);
		$l = str_replace("##LABEL##",urlencode($label),$l);

		printf("\t\t\t<OPTION VALUE=\"%s\">%s</OPTION>\n",htmlspecialchars($l),$parts[0]);
	}
?>
	</SELECT>
	<INPUT TYPE=SUBMIT VALUE="View Map">
</FORM>
<?
}

function getHopsUrl($term) {
	return sprintf("http://%s/datamart/igate-hops/hops-switch.php?name=%s",DATAMART_HOST,urlencode($term));
}


?>
