<?
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT"); // Date in the past
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); // always modified
header("Cache-Control: no-cache, must-revalidate"); // for HTTP/1.1
header("Pragma: no-cache"); // for HTTP/1.0

require $_SERVER["DOCUMENT_ROOT"] . "/world_config.php";

/*

set title "Wind speed at ##CALL##"
set ylabel "Wind speed in ##UNITS##"
set size ##SIZE## 

plot "##DATAFILE_PATH##" using 1:5 title "" with lines
*/


switch ( $_REQUEST["type"] ) {
	/* weather plots */
	case "temperature":
		$template_file = "temperature.plot";
		$column=3;
		break;
	case "wind_direction":
		$template_file = "wind_direction.plot";
		$column=4;
		break;
	case "wind_speed":
		$template_file = "wind_speed.plot";
		$column=5;
		break;
	case "wind_gust":
		$template_file = "wind_gust.plot";
		$column=6;
		break;
	case "rain_hour":
		$template_file = "rain_hour.plot";
		$column=7;
		break;
	case "rain_day":
		$template_file = "rain_day.plot";
		$column=8;
		break;
	case "rain_midnight":
		$template_file = "rain_midnight.plot";
		$column=9;
		break;
	case "barometer":
		$template_file = "barometer.plot";
		$column=10;
		break;
	case "humidity":
		$template_file = "humidity.plot";
		$column=11;
		break;
	/* track plots */
	case "altitude":
		$template_file = "altitude.plot";
		$column=3;
		break;
	case "speed":
		$template_file = "speed.plot";
		$column=4;
		break;
	case "delta_altitude":
		$template_file = "delta_altitude.plot";
		$column=5;
		break;
	case "delta_speed":
		$template_file = "delta_speed.plot";
		$column=6;
		break;
	default:
		error_image("Unknown image type: " . $_REQUEST["type"] );
		break;
}


$call = strtoupper($_REQUEST["call"]);
$filename = $_REQUEST["filename"];


if ( "" == $_REQUEST["call"] ) {
	error_image("No callsign specified");
}

if ( ! file_exists($filename) ) {
	error_image("Data file not accessable");
}


if ( "" == $_REQUEST["units"] ) {
	$units = "unknown";
} else {
	$units=$_REQUEST["units"];
}

$afile = file(GNUPLOT_TEMPLATE_PATH . "/" . $template_file );
$template = implode("",$afile);

$our_plot_file = $filename . "." . $_REQUEST["type"] . ".plot";

/* replace the markers with the values we need */
$template = str_replace("##CALL##",$call,$template);
$template = str_replace("##UNITS##",$units,$template);
$template = str_replace("##SIZE##","1.10, 0.50",$template);
$template = str_replace("##DATAFILE_PATH##",$filename,$template);
$template = str_replace("##COLUMN##",$column,$template);



/* if we are debugging then we will send back plain text */
if ( $_REQUEST["debug"] ) {
	header("Content-type: text/plain");
	
	printf("filename: %s\n",$filename);
	printf("our_plot_file: %s\n",$our_plot_file);
	printf("%s",$template);

	
} else {
	$fp = fopen($our_plot_file,"w");
	fputs($fp, $template);
	fclose($fp);


	header("Content-type: image/png");
	$command = sprintf("gnuplot %s",$our_plot_file);
	passthru($command);

}





?>
