<?
/* array of key (what to convert) and value (description of it)
$convert_array[celfar] = "degrees Celsius to Fahrenheit";
$convert_array[farcel] = "degrees Fahrenheit to Celsius";
$convert_array[cmin] = "centimeters to inches";
$convert_array[incm] = "inches to centimeters";
$convert_array[mefe] = "meters to feet";
$convert_array[feme] = "feet to meters";
$convert_array[kmmi] = "kilometers to miles";
$convert_array[mikm] = "miles to kilometers";
$convert_array[kglb] = "kilograms to pounds";
$convert_array[lbkg] = "pounds to kilograms";
$convert_array[mloz] = "milliliters to ounces";
$convert_array[ozml] = "ounces to milliliters";
$convert_array[rbtb] = "regular beers to tall beers";
$convert_array[tbrb] = "tall beers to regular beers";
*/

function cvrt($value,$convert,$metric=1,$units="") {
	if ( $metric )
		return $value;

   switch($convert)
   {
	case "mbinhg":
			$result = ($value*0.02952998);
			break;
   case "celfar":
        $result = ($value*1.8) +32;
        $unit1 = "degree";
        $unit1 .= $plural;
        $unit1 .= "&nbsp;celsius (C)";
        $unit2 = "degrees fahrenheit (F)";
   break;
   case "farcel":
        $result = ($value - 32) * 0.5556;
        $unit1 = "degree";
        $unit1 .= $plural;
        $unit1 .= "&nbsp;fahrenheit (F)";
        $unit2 = "degrees celsius (C)";
   break;
   case "cmin":
        $result = $value * 0.393701;
        $unit1 = "centimeter";
        $unit1 .= $plural;
        $unit2 = "inches";
   break;
   case "incm":
        $result = $value * 2.54;
        $unit1 = "inch";
        if ($plural == "s") {
                $plural = "es";
                }
        $unit1 .= $plural;
        $unit2 = "centimeters";
   break;
   case "mefe":
        $result = $value * 3.28084;
        $unit1 = "meter";
        $unit1 .= $plural;
        $unit2 = "feet";
   break;
   case "feme":
        $result = $value * 0.3048;
        if ($plural != "s") {
                $unit1 = "foot";
                } else {
                $unit1 = "feet";
                }
        $unit2 = "meters";
   break;
   case "kmmi":
        $result = $value * 0.621371;
        $unit1 = "kilometer";
        $unit1 .= $plural;
        $unit1 .= "&nbsp;(km)";
        $unit2 = "miles (mi)";
  break;
  case "mikm":
        $result = $value * 1.60934;
        $unit1 = "mile";
        $unit1 .= $plural;
        $unit1 .= "&nbsp;(mi)";
        $unit2 = "kilometers (km)";
  break;
  case "kglb":
        $result = $value * 2.20462;
        $unit1 = "kilogram";
        $unit1 .= $plural;
        $unit1 .= "&nbsp;(kg)";
        $unit2 = "pounds (lb)";
  break;
  case "lbkg":
        $result = $value * 0.453592;
        $unit1 = "pound";
        $unit1 .= $plural;
        $unit1 .= "&nbsp;(lb)";
        $unit2 = "kilograms (kg)";
  break;
  case "mloz":
        $result = $value * 0.0338146;
        $resultUK = $value * 0.035195083;
        $unit1 = "milliliter";
        $unit1 .= $plural;
        $unit1 .= "&nbsp;(ml)";
        $unit2 = "U.S. ounces (oz), or&nbsp;";
        $unit2 .= number_format($resultUK, "3", ".", ",");
        $unit2 .= "&nbsp;ounces in British measurement. <br><i>(1 US oz is 1.0408 UK oz)</i>";
  break;
  case "ozml":
        $result = $value * 29.57303;
        $resultUK = $value * 28.41306;
        $unit1 = "ounce";
        $unit1 .= $plural;
        $unit1 .= "&nbsp;(oz)";
        $unit2 = "milliliters, but only if you're using US ounces. <br>If you're using British ounces, the answer is&nbsp;";
        $unit2 .= number_format($resultUK, "2", ".", ",");
        $unit2 .= "&nbsp;milliliters (because one US oz is 1.0408 UK oz)";
  break;

	default:	$result = "Unknown conversion";
}

return $result;
}


