<?
require "../world_config.php";
require "metric.php";

function speed_units($metric) {
	if ( $metric )
		return "KPH";
	return "MPH";
}

function rain_units($metric) {
	if ( $metric )
		return " cm";
	return "\"";
}

function temperature_units($metric) {
	if ( $metric )
		return "C";
	return "F";
}

function altitude_units($metric) {
	if ( $metric )
		return "M";
	return "ft";
}

function barometer_units($metric) {
	if ( $metric )
		return " millibars";
	return "\" Hg";
}

$call = strtoupper($call);


$db = _open_mysql("aprs");

$query = sprintf("SELECT lastweather.*, lastposition.latitude, lastposition.longitude FROM lastweather LEFT JOIN lastposition ON lastweather.source=lastposition.source WHERE lastweather.source='%s' LIMIT 1",$call);
$q = mysql_query($query,$db);

$record = mysql_fetch_array($q);

if ( $label == "" )
	$label=sprintf("%s  (%.4lf %.4lf)",$call,$record["latitude"],$record["longitude"]);

$label=stripslashes($label);

$line1 = sprintf("%s  Last Report: %s UTC\r\nTemperature: %d &#176;%s  Relative Humidity: %02d%% Barometer: %.2lf%s\r\nWind - Speed: %d %s  Gust: %d %s  Sustained: %d %s  Direction: %d&#176;\r\nRain - Last Hour: %01.2lf%s  Day: %01.2lf%s  Since Midnight: %01.2lf%s",
	$label,
	$record["packet_date"],
	cvrt($record["temperature"],"celfar",$metric),temperature_units($metric),
	$record["humidity"],
	cvrt($record["barometer"],"mbinhg",$metric),barometer_units($metric),
	cvrt($record["wind_speed"],"kmmi",$metric),speed_units($metric),
	cvrt($record["wind_gust"],"kmmi",$metric),speed_units($metric),
	cvrt($record["wind_sustained"],"kmmi",$metric),speed_units($metric),
	$record["wind_direction"],
	cvrt($record["rain_hour"],"cmin",$metric),rain_units($metric),
	cvrt($record["rain_day"],"cmin",$metric),rain_units($metric),
	cvrt($record["rain_midnight"],"cmin",$metric),rain_units($metric)
	);

$width = $_REQUEST["width"];
$textcolor = $_REQUEST["textcolor"];
$backgroundcolor= $_REQUEST["backgroundcolor"];

if ( 0 == $width )
	$width=600;
if ( 0 == $height )
	$height=95;

if ( "" == $textcolor ) {
	$textcolor="000099";
}
if ( "" == $backgroundcolor ) {
	$backgroundcolor="FFFFFF";
}

list($tr,$tg,$tb) = sscanf(strtoupper($textcolor),"%2x%2x%2x");
list($br,$bg,$bb) = sscanf(strtoupper($backgroundcolor),"%2x%2x%2x");


$png = ImageCreate($width,$height);
$bg = ImageColorAllocate($png,$br,$bg,$bb);
$tx = ImageColorAllocate($png,$tr,$tg,$tb);


/* some people don't want the icon to show */
if (  $_REQUEST["noicon"] ) {

	Imagettftext ($png, 11, 0, 5, 20, $tx, TTF_FONT_PATH . "/arial.ttf", $line1);
} else {
	Imagettftext ($png, 11, 0, 64, 20, $tx, TTF_FONT_PATH . "/arial.ttf", $line1);

/* select the appropriate icon to include ... from our ... (cough) vast collection */
$insert_file = "wx_sunny.png";
if ( $record["rain_hour"] != 0 ) {
	$insert_file="wx_rain.png";
	if ( $record["temperature"] < 0 ) {
		/* it's cold out, it must be snowing */
		$insert_file="wx_snow.png";
	}
}

/*
$insert_file = "small_sunny.png";
if ( $record["rain_hour"] != 0 ) {
	$insert_file="small_shower3.png";
	if ( $record["temperature"] < 0 ) {
		// it's cold out, it must be snowing 
		$insert_file="small_snow4.png";
	}
}
$insert_file = $_SERVER["DOCUMENT_ROOT"] . "/datamart/wximages/" . $insert_file;
*/ 

$insert_file = $_SERVER["DOCUMENT_ROOT"] . "/images/weather/" . $insert_file;

$insert = imagecreatefrompng( $insert_file );

// Either a color at a specific point on the image
// imagecolortransparent($insert,imagecolorat($insert,0,0));
// or a specific color (the color I used is magenta, #ff00ff)
imagecolortransparent($insert,imagecolorat($insert,0,0));

$insert_x = imagesx($insert);
$insert_y = imagesy($insert);

// As said above, you can't use imagecopy (bug?)
imagecopymerge($png,$insert,8,20,0,0,$insert_x,$insert_y,100);
}

// send the image
header("content-type: image/png");
ImagePng($png); 
?>
